<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: example2DWalking.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('example2DWalking_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">example2DWalking.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This example conducts a 2-D prediction of walking, employing a MocoPerodicityGoal.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: example2DWalking.m                                           %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2019 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Brian Umberger                                                  %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">% This is a Matlab implementation of an example optimal control</div>
<div class="line">% problem (2-D walking) orginally created in C++ by Antoine Falisse</div>
<div class="line">% (see: example2DWalking.cpp).</div>
<div class="line">%</div>
<div class="line">% This example features two different optimal control problems:</div>
<div class="line">%  - The first problem is a tracking simulation of walking.</div>
<div class="line">%  - The second problem is a predictive simulation of walking.</div>
<div class="line">%</div>
<div class="line">% The code is inspired from Falisse A, Serrancoli G, Dembia C, Gillis J,</div>
<div class="line">% De Groote F: Algorithmic differentiation improves the computational</div>
<div class="line">% efficiency of OpenSim-based trajectory optimization of human movement.</div>
<div class="line">% PLOS One, 2019.</div>
<div class="line">%</div>
<div class="line">% Model</div>
<div class="line">% -----</div>
<div class="line">% The model described in the file &#39;2D_gait.osim&#39; included in this file is a</div>
<div class="line">% modified version of the &#39;gait10dof18musc.osim&#39; available within OpenSim. We</div>
<div class="line">% replaced the moving knee flexion axis by a fixed flexion axis, replaced the</div>
<div class="line">% Millard2012EquilibriumMuscles by DeGrooteFregly2016Muscles, and added</div>
<div class="line">% SmoothSphereHalfSpaceForces (two contacts per foot) to model the</div>
<div class="line">% contact interactions between the feet and the ground.</div>
<div class="line">%</div>
<div class="line">% Do not use this model for research. The path of the gastroc muscle contains</div>
<div class="line">% an error--the path does not cross the knee joint.</div>
<div class="line">%</div>
<div class="line">% Data</div>
<div class="line">% ----</div>
<div class="line">% The coordinate data included in the &#39;referenceCoordinates.sto&#39; comes from</div>
<div class="line">% predictive simulations generated in Falisse et al. 2019.  As such,</div>
<div class="line">% they deviate slightly from typical experimental gait data.</div>
<div class="line"> </div>
<div class="line">clear;</div>
<div class="line"> </div>
<div class="line">% Load the Moco libraries</div>
<div class="line"><span class="keyword">import</span> org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% ---------------------------------------------------------------------------</div>
<div class="line">% Set up a coordinate tracking problem where the goal is to minimize the</div>
<div class="line">% difference between provided and simulated coordinate values and speeds (and</div>
<div class="line">% ground reaction forces), as well as to minimize an effort cost (squared</div>
<div class="line">% controls). The provided data represents half a gait cycle. Endpoint</div>
<div class="line">% constraints enforce periodicity of the coordinate values (except for</div>
<div class="line">% pelvis tx) and speeds, coordinate actuator controls, and muscle activations.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem</div>
<div class="line">% ==================================</div>
<div class="line">track = MocoTrack();</div>
<div class="line">track.setName(<span class="stringliteral">&#39;gaitTracking&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Set the weights <span class="keywordflow">for</span> the terms in the objective <span class="keyword">function</span>. The values below were</div>
<div class="line">% obtained by trial and error.</div>
<div class="line">%</div>
<div class="line">% Note: If GRFTrackingWeight is <span class="keyword">set</span> to 0 then GRFs will not be tracked. Setting</div>
<div class="line">% GRFTrackingWeight to 1 will cause the total tracking error (states + GRF) to</div>
<div class="line">% have about the same magnitude as control effort in the <span class="keyword">final</span> objective value.</div>
<div class="line">controlEffortWeight = 10;</div>
<div class="line">stateTrackingWeight = 1;</div>
<div class="line">GRFTrackingWeight   = 1;</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Reference data <span class="keywordflow">for</span> tracking problem</div>
<div class="line">tableProcessor = TableProcessor(<span class="stringliteral">&#39;referenceCoordinates.sto&#39;</span>);</div>
<div class="line">tableProcessor.append(TabOpLowPassFilter(6));</div>
<div class="line"> </div>
<div class="line">modelProcessor = ModelProcessor(<span class="stringliteral">&#39;2D_gait.osim&#39;</span>);</div>
<div class="line">track.setModel(modelProcessor);</div>
<div class="line">track.setStatesReference(tableProcessor);</div>
<div class="line">track.set_states_global_tracking_weight(stateTrackingWeight);</div>
<div class="line">track.set_allow_unused_references(<span class="keyword">true</span>);</div>
<div class="line">track.set_track_reference_position_derivatives(<span class="keyword">true</span>);</div>
<div class="line">track.set_apply_tracked_states_to_guess(<span class="keyword">true</span>);</div>
<div class="line">track.set_initial_time(0.0);</div>
<div class="line">track.set_final_time(0.47008941);</div>
<div class="line">study = track.initialize();</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Goals</div>
<div class="line">% =====</div>
<div class="line"> </div>
<div class="line">% Symmetry</div>
<div class="line">% --------</div>
<div class="line">% This goal allows us to <a name="a0"></a><a class="code" href="group__simulationutil.html#ga5821a4ca8e6fe9b0cb2b5492665b5dc0">simulate</a> only one step with left-right symmetry</div>
<div class="line">% that we can then <span class="keywordtype">double</span> to create a full gait cycle.</div>
<div class="line">symmetryGoal = MocoPeriodicityGoal(&#39;symmetryGoal&#39;);</div>
<div class="line">problem.addGoal(symmetryGoal);</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">model.initSystem();</div>
<div class="line"> </div>
<div class="line">% Symmetric coordinate values (except <span class="keywordflow">for</span> pelvis_tx) and speeds. Here, we </div>
<div class="line">% constrain <span class="keyword">final</span> coordinate values of one leg to match the initial value of the </div>
<div class="line">% other leg. Or, in the <span class="keywordflow">case</span> of the pelvis_tx value, we constrain the <span class="keyword">final</span> </div>
<div class="line">% value to be the same as the initial value.</div>
<div class="line">for i = 1:model.getNumStateVariables()</div>
<div class="line">    currentStateName = string(model.getStateVariableNames().getitem(i-1));</div>
<div class="line">    <span class="keywordflow">if</span> startsWith(currentStateName , <span class="stringliteral">&#39;/jointset&#39;</span>)</div>
<div class="line">        if contains(currentStateName,&#39;_r&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_r&#39;,&#39;_l&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if contains(currentStateName,&#39;_l&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_l&#39;,&#39;_r&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if (~contains(currentStateName,&#39;_r&#39;) &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;_l&#39;) &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;pelvis_tx/value&#39;) &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;/activation&#39;))</div>
<div class="line">            symmetryGoal.addStatePair(MocoPeriodicityGoalPair(currentStateName));</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Symmetric muscle activations. Here, we constrain final muscle activation </div>
<div class="line">% values of one leg to match the initial activation values of the other leg.</div>
<div class="line">for i = 1:model.getNumStateVariables()</div>
<div class="line">    currentStateName = <span class="keywordtype">string</span>(model.getStateVariableNames().getitem(i-1));</div>
<div class="line">    if endsWith(currentStateName,&#39;/activation&#39;)</div>
<div class="line">        if contains(currentStateName,&#39;_r&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                         regexprep(currentStateName,&#39;_r&#39;,&#39;_l&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if contains(currentStateName,&#39;_l&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                         regexprep(currentStateName,&#39;_l&#39;,&#39;_r&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% The lumbar coordinate actuator control is symmetric.</div>
<div class="line">symmetryGoal.addControlPair(MocoPeriodicityGoalPair(&#39;/lumbarAct&#39;));</div>
<div class="line"> </div>
<div class="line">% Get a reference to the MocoControlGoal that is added to every MocoTrack</div>
<div class="line">% problem by default and change the weight</div>
<div class="line">effort = MocoControlGoal.safeDownCast(problem.updGoal(&#39;control_effort&#39;));</div>
<div class="line">effort.setWeight(controlEffortWeight);</div>
<div class="line"> </div>
<div class="line">% Optionally, add a contact tracking goal.</div>
<div class="line">if GRFTrackingWeight ~= 0</div>
<div class="line">    % Track the right and left vertical and fore-aft ground reaction forces.</div>
<div class="line">    contactTracking = MocoContactTrackingGoal(&#39;contact&#39;, GRFTrackingWeight);</div>
<div class="line">    contactTracking.setExternalLoadsFile(&#39;referenceGRF.xml&#39;);</div>
<div class="line">    forceNamesRightFoot = StdVectorString();</div>
<div class="line">    forceNamesRightFoot.add(&#39;contactHeel_r&#39;);</div>
<div class="line">    forceNamesRightFoot.add(&#39;contactFront_r&#39;);</div>
<div class="line">    contactTracking.addContactGroup(forceNamesRightFoot, &#39;Right_GRF&#39;);</div>
<div class="line">    forceNamesLeftFoot = StdVectorString();</div>
<div class="line">    forceNamesLeftFoot.add(&#39;contactHeel_l&#39;);</div>
<div class="line">    forceNamesLeftFoot.add(&#39;contactFront_l&#39;);</div>
<div class="line">    contactTracking.addContactGroup(forceNamesLeftFoot, &#39;Left_GRF&#39;);</div>
<div class="line">    contactTracking.setProjection(&#39;plane&#39;);</div>
<div class="line">    contactTracking.setProjectionVector(Vec3(0, 0, 1));</div>
<div class="line">    problem.addGoal(contactTracking);</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Bounds</div>
<div class="line">% ======</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_tilt/value&#39;, [-20*pi/180, -10*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_tx/value&#39;, [0, 1]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_ty/value&#39;, [0.75, 1.25]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/hip_l/hip_flexion_l/value&#39;, [-10*pi/180, 60*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/hip_r/hip_flexion_r/value&#39;, [-10*pi/180, 60*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/knee_l/knee_angle_l/value&#39;, [-50*pi/180, 0]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/knee_r/knee_angle_r/value&#39;, [-50*pi/180, 0]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/ankle_l/ankle_angle_l/value&#39;, [-15*pi/180, 25*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/ankle_r/ankle_angle_r/value&#39;, [-15*pi/180, 25*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/lumbar/lumbar/value&#39;, [0, 20*pi/180]);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Solve the problem</div>
<div class="line">% =================</div>
<div class="line">gaitTrackingSolution = study.solve();</div>
<div class="line"> </div>
<div class="line">% Create a full stride from the periodic single step solution.</div>
<div class="line">% For details, view the Doxygen documentation for <a name="a1"></a><a class="code" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">createPeriodicTrajectory</a>().</div>
<div class="line">fullStride = opensimMoco.<a class="code" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">createPeriodicTrajectory</a>(gaitTrackingSolution);</div>
<div class="line">fullStride.write(&#39;gaitTracking_solution_fullStride.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Uncomment next line to visualize the result</div>
<div class="line">% study.visualize(fullStride);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Extract ground reaction forces</div>
<div class="line">% ==============================</div>
<div class="line">contact_r = StdVectorString();</div>
<div class="line">contact_l = StdVectorString();</div>
<div class="line">contact_r.add(&#39;contactHeel_r&#39;);</div>
<div class="line">contact_r.add(&#39;contactFront_r&#39;);</div>
<div class="line">contact_l.add(&#39;contactHeel_l&#39;);</div>
<div class="line">contact_l.add(&#39;contactFront_l&#39;);</div>
<div class="line"> </div>
<div class="line">externalForcesTableFlat = opensimMoco.<a name="a2"></a><a class="code" href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">createExternalLoadsTableForGait</a>(model, ...</div>
<div class="line">                                 fullStride,contact_r,contact_l);</div>
<div class="line">STOFileAdapter.write(externalForcesTableFlat, ...</div>
<div class="line">                             &#39;gaitTracking_solutionGRF_fullStride.sto&#39;);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Uncomment next line to terminate after solving only the tracking problem</div>
<div class="line">% return;</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">%------------------------------------------------------------------------</div>
<div class="line">% Set up a gait prediction problem where the goal is to minimize effort</div>
<div class="line">% (squared controls) divided by distance traveled while enforcing symmetry of</div>
<div class="line">% the walking cycle and a prescribed average gait speed through endpoint</div>
<div class="line">% constraints. The solution of the coordinate tracking problem is</div>
<div class="line">% used as an initial guess for the prediction.</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem</div>
<div class="line">% ==================================</div>
<div class="line">study = MocoStudy();</div>
<div class="line">study.setName(&#39;gaitPrediction&#39;);</div>
<div class="line"> </div>
<div class="line">problem = study.updProblem();</div>
<div class="line">modelProcessor = ModelProcessor(&#39;2D_gait.osim&#39;);</div>
<div class="line">problem.setModelProcessor(modelProcessor);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Goals</div>
<div class="line">% =====</div>
<div class="line"> </div>
<div class="line">% Symmetry (to permit simulating only one step)</div>
<div class="line">symmetryGoal = MocoPeriodicityGoal(&#39;symmetryGoal&#39;);</div>
<div class="line">problem.addGoal(symmetryGoal);</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">model.initSystem();</div>
<div class="line"> </div>
<div class="line">% Symmetric coordinate values (except for pelvis_tx) and speeds</div>
<div class="line">for i = 1:model.getNumStateVariables()</div>
<div class="line">    currentStateName = <span class="keywordtype">string</span>(model.getStateVariableNames().getitem(i-1));</div>
<div class="line">    if startsWith(currentStateName , &#39;/jointset&#39;)</div>
<div class="line">        if contains(currentStateName,&#39;_r&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_r&#39;,&#39;_l&#39;) );</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if contains(currentStateName,&#39;_l&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_l&#39;,&#39;_r&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if (~contains(currentStateName,&#39;_r&#39;) &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;_l&#39;) &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;pelvis_tx/value&#39;)  &amp;&amp; ...</div>
<div class="line">            ~contains(currentStateName,&#39;/activation&#39;))</div>
<div class="line">            symmetryGoal.addStatePair(MocoPeriodicityGoalPair(currentStateName));</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Symmetric muscle activations</div>
<div class="line">for i = 1:model.getNumStateVariables()</div>
<div class="line">    currentStateName = <span class="keywordtype">string</span>(model.getStateVariableNames().getitem(i-1));</div>
<div class="line">    if endsWith(currentStateName,&#39;/activation&#39;)</div>
<div class="line">        if contains(currentStateName,&#39;_r&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_r&#39;,&#39;_l&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">        if contains(currentStateName,&#39;_l&#39;)</div>
<div class="line">            pair = MocoPeriodicityGoalPair(currentStateName, ...</div>
<div class="line">                           regexprep(currentStateName,&#39;_l&#39;,&#39;_r&#39;));</div>
<div class="line">            symmetryGoal.addStatePair(pair);</div>
<div class="line">        end</div>
<div class="line">    end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Symmetric coordinate actuator controls</div>
<div class="line">symmetryGoal.addControlPair(MocoPeriodicityGoalPair(&#39;/lumbarAct&#39;));</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Prescribed average gait speed</div>
<div class="line">speedGoal = MocoAverageSpeedGoal(&#39;speed&#39;);</div>
<div class="line">problem.addGoal(speedGoal);</div>
<div class="line">speedGoal.set_desired_average_speed(1.2);</div>
<div class="line"> </div>
<div class="line">% Effort over distance</div>
<div class="line">effortGoal = MocoControlGoal(&#39;effort&#39;, 10);</div>
<div class="line">problem.addGoal(effortGoal);</div>
<div class="line">effortGoal.setExponent(3);</div>
<div class="line">effortGoal.setDivideByDisplacement(true);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Bounds</div>
<div class="line">% ======</div>
<div class="line">problem.setTimeBounds(0, [0.4, 0.6]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_tilt/value&#39;, [-20*pi/180, -10*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_tx/value&#39;, [0, 1]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/groundPelvis/pelvis_ty/value&#39;, [0.75, 1.25]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/hip_l/hip_flexion_l/value&#39;, [-10*pi/180, 60*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/hip_r/hip_flexion_r/value&#39;, [-10*pi/180, 60*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/knee_l/knee_angle_l/value&#39;, [-50*pi/180, 0]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/knee_r/knee_angle_r/value&#39;, [-50*pi/180, 0]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/ankle_l/ankle_angle_l/value&#39;, [-15*pi/180, 25*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/ankle_r/ankle_angle_r/value&#39;, [-15*pi/180, 25*pi/180]);</div>
<div class="line">problem.setStateInfo(&#39;/jointset/lumbar/lumbar/value&#39;, [0, 20*pi/180]);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Configure the solver</div>
<div class="line">% ====================</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals(50);</div>
<div class="line">solver.set_verbosity(2);</div>
<div class="line">solver.set_optim_solver(&#39;ipopt&#39;);</div>
<div class="line">solver.set_optim_convergence_tolerance(1e-4);</div>
<div class="line">solver.set_optim_constraint_tolerance(1e-4);</div>
<div class="line">solver.set_optim_max_iterations(1000);</div>
<div class="line">solver.setGuess(gaitTrackingSolution); % Use tracking solution as initial guess</div>
<div class="line"> </div>
<div class="line">% Solve problem</div>
<div class="line">% =============</div>
<div class="line">gaitPredictionSolution = study.solve();</div>
<div class="line"> </div>
<div class="line">% Create a full stride from the periodic single step solution.</div>
<div class="line">% For details, view the Doxygen documentation for <a class="code" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">createPeriodicTrajectory</a>().</div>
<div class="line">fullStride = opensimMoco.<a class="code" href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">createPeriodicTrajectory</a>(gaitPredictionSolution);</div>
<div class="line">fullStride.write(&#39;gaitPrediction_solution_fullStride.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Visualize the result.</div>
<div class="line">study.visualize(fullStride);</div>
<div class="line"> </div>
<div class="line">% Extract ground reaction forces</div>
<div class="line">% ==============================</div>
<div class="line">contact_r = StdVectorString();</div>
<div class="line">contact_l = StdVectorString();</div>
<div class="line">contact_r.add(&#39;contactHeel_r&#39;);</div>
<div class="line">contact_r.add(&#39;contactFront_r&#39;);</div>
<div class="line">contact_l.add(&#39;contactHeel_l&#39;);</div>
<div class="line">contact_l.add(&#39;contactFront_l&#39;);</div>
<div class="line"> </div>
<div class="line">% Create a conventional ground reaction forces file by summing the contact</div>
<div class="line">% forces of contact spheres on each foot.</div>
<div class="line">% For details, view the Doxygen documentation for</div>
<div class="line">% <a class="code" href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">createExternalLoadsTableForGait</a>().</div>
<div class="line">externalForcesTableFlat = opensimMoco.<a class="code" href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">createExternalLoadsTableForGait</a>(model, ...</div>
<div class="line">                             fullStride, contact_r, contact_l);</div>
<div class="line">STOFileAdapter.write(externalForcesTableFlat, ...</div>
<div class="line">                             &#39;gaitPrediction_solutionGRF_fullStride.sto&#39;);</div>
<div class="ttc" id="agroup__mocoutil_html_ga2a8c0203ebf6babc23168bc4cd76fa68"><div class="ttname"><a href="group__mocoutil.html#ga2a8c0203ebf6babc23168bc4cd76fa68">OpenSim::createPeriodicTrajectory</a></div><div class="ttdeci">OSIMMOCO_API MocoTrajectory createPeriodicTrajectory(const MocoTrajectory &amp;halfPeriodTrajectory, std::vector&lt; std::string &gt; addPatterns={&quot;.*pelvis_tx/value&quot;}, std::vector&lt; std::string &gt; negatePatterns={ &quot;.*pelvis_list(?!/value).*&quot;, &quot;.*pelvis_rotation.*&quot;, &quot;.*pelvis_tz(?!/value).*&quot;, &quot;.*lumbar_bending(?!/value).*&quot;, &quot;.*lumbar_rotation.*&quot;}, std::vector&lt; std::string &gt; negateAndShiftPatterns={ &quot;.*pelvis_list/value&quot;, &quot;.*pelvis_tz/value&quot;, &quot;.*lumbar_bending/value&quot;}, std::vector&lt; std::pair&lt; std::string, std::string &gt;&gt; symmetryPatterns={{R&quot;(_r(\/|_|$))&quot;, &quot;_l$1&quot;}, {R&quot;(_l(\/|_|$))&quot;, &quot;_r$1&quot;}})</div><div class="ttdoc">Convert a trajectory covering half the period of a symmetric motion into a trajectory over the full p...</div></div>
<div class="ttc" id="agroup__mocoutil_html_gafe5751c42bc6997f76768ee9cb20323f"><div class="ttname"><a href="group__mocoutil.html#gafe5751c42bc6997f76768ee9cb20323f">OpenSim::createExternalLoadsTableForGait</a></div><div class="ttdeci">OSIMMOCO_API TimeSeriesTable createExternalLoadsTableForGait(Model model, const StatesTrajectory &amp;trajectory, const std::vector&lt; std::string &gt; &amp;forcePathsRightFoot, const std::vector&lt; std::string &gt; &amp;forcePathsLeftFoot)</div><div class="ttdoc">Obtain the ground reaction forces, centers of pressure, and torques resulting from Force elements (e....</div></div>
<div class="ttc" id="agroup__simulationutil_html_ga5821a4ca8e6fe9b0cb2b5492665b5dc0"><div class="ttname"><a href="group__simulationutil.html#ga5821a4ca8e6fe9b0cb2b5492665b5dc0">OpenSim::simulate</a></div><div class="ttdeci">OSIMSIMULATION_API SimTK::State simulate(Model &amp;model, const SimTK::State &amp;initialState, double finalTime, bool saveStatesFile=false)</div><div class="ttdoc">Simulate a model from an initial state and return the final state.</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
